// sawFFT_JE.ck
// John Ellinger Music 208 Winter2014

SndBuf buf => FFT fft => blackhole;
buf.read( me.sourceDir() + "/saw300.wav" );

<<< "buf.length", buf.length() >>>;
0 => buf.pos;

// Set FFT size
4096 => fft.size;

// the blob will collect results from the FFT
UAnaBlob blob;

// declare an array to hold the FFT magnitude spectrum
// obtained through the blob
float mag_spec[]; 

now + buf.length() => time later;
while (now < later) 
{
	// let fft.size samples samples pass
	fft.size()::samp => now;
	// trigger the FFT computation on the last 2048 samples (the FFT size)
	fft.upchuck() @=> blob;	
	blob.fvals() @=> mag_spec; // get the magnitude spectrum as float array
	
	largestMag() => int maxBin;
	44100.0/fft.size() => float binFreq;
	
	<<< "maxBin", maxBin >>>;
	<<< "binFreq", binFreq >>>;
	<<< "estFreq", maxBin * binFreq >>>;
	
}

function int largestMag()
{
	0 => int binX;
	0 => float maxMag;
	for ( 0 => int ix; ix < fft.size()/2; ix++ )
	{
		if ( mag_spec[ix] > maxMag )
		{
			mag_spec[ix] => maxMag;
			ix => binX;
		}
	}
	return binX;
}

